=== install/debian/control ===
Source: openxcom
Section: games
Priority: extra
Maintainer: Krzysztof Knapik <knapsu@gmail.com>
Build-Depends:
	debhelper (>=9),
	cmake,
	libsdl1.2-dev,
	libsdl-mixer1.2-dev,
	libsdl-gfx1.2-dev,
	libsdl-image1.2-dev,
	libyaml-cpp-dev (>= 0.5.3),
	libboost-dev
Standards-Version: 3.9.6
Homepage: https://openxcom.org/
Vcs-Git: git://github.com/OpenXcom/OpenXcom.git
Vcs-Browser: https://github.com/OpenXcom/OpenXcom

Package: openxcom
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Open-source clone of UFO: Enemy Unknown
 OpenXcom is an open-source clone of the popular UFO: Enemy Unknown (X-COM: UFO Defense in USA)
 turn-based strategy game by MicroProse. It is written in C++ / SDL and licensed under the GPL.
 OpenXcom requires game resources from the original game (DOS, Windows or Steam version).
